<div class="row space">
  <div class="col">
    <mat-card class="card-style mr-auto ml-auto" matRipple>
      <mat-card-header>
        <mat-card-title>Race {{race.racePositionIndex + 1}} in {{race.circuit}}</mat-card-title>
        <mat-card-subtitle>Racedate: {{race.raceDate}} </mat-card-subtitle>
        <div *ngIf="isEditor" class="ml-auto align-self-start">
          <button (click)="forwardToAddRaceResult()" color="warn" mat-mini-fab>
            <mat-icon>add</mat-icon>
          </button>
        </div>
      </mat-card-header>
      <mat-divider></mat-divider>
      <mat-card-content>
        <div *ngIf="race.hasBeenDriven">
          <mat-accordion (click)="loadResults()">
            <mat-expansion-panel style="margin-top: 15px">
              <mat-expansion-panel-header>
                <mat-panel-title>
                  Results
                </mat-panel-title>
              </mat-expansion-panel-header>
              <div *ngIf="!loaded">
                <mat-progress-bar mode="buffer"></mat-progress-bar>
              </div>
              <div *ngIf="loaded">
                <table [dataSource]="dataSource" class="mat-elevation-z8" mat-table>
                  <ng-container matColumnDef="endPosition">
                    <th *matHeaderCellDef mat-header-cell> Endposition</th>
                    <td *matCellDef="let raceResult" mat-cell> {{raceResult.endPosition}} </td>
                  </ng-container>

                  <ng-container matColumnDef="driver">
                    <th *matHeaderCellDef mat-header-cell> Driver</th>
                    <td *matCellDef="let raceResult" mat-cell> {{raceResult.driver}} </td>
                  </ng-container>

                  <ng-container matColumnDef="grid">
                    <th *matHeaderCellDef mat-header-cell> Grid</th>
                    <td *matCellDef="let raceResult" mat-cell> {{raceResult.grid}} </td>
                  </ng-container>

                  <ng-container matColumnDef="points">
                    <th *matHeaderCellDef mat-header-cell> Points</th>
                    <td *matCellDef="let raceResult" mat-cell> {{raceResult.points}} </td>
                  </ng-container>

                  <ng-container matColumnDef="fastestLap">
                    <th *matHeaderCellDef mat-header-cell> Fastest</th>
                    <td *matCellDef="let raceResult" [ngClass]="{'fastest': raceResult.hasFastestLap}"
                        mat-cell> {{raceResult.fastestLap | timePipe}} </td>
                  </ng-container>

                  <ng-container matColumnDef="car">
                    <th *matHeaderCellDef mat-header-cell> Car</th>
                    <td *matCellDef="let raceResult" mat-cell> {{raceResult.car}} </td>
                  </ng-container>

                  <tr *matHeaderRowDef="columnsToDisplay" mat-header-row></tr>
                  <tr *matRowDef="let row; columns: columnsToDisplay;" mat-row></tr>
                </table>
              </div>
            </mat-expansion-panel>
          </mat-accordion>
        </div>
        <div *ngIf="!race.hasBeenDriven">
          <mat-list-item class="driverListItem">Race has not been driven</mat-list-item>
        </div>
      </mat-card-content>
    </mat-card>
  </div>
</div>
